a <- -8/3
b <- -10
c <-  28

dx <- function(x,y,z) a*x + y*z
dy <- function(x,y,z) b*(y-z)
dz <- function(x,y,z) -x*y + c*y - z

dt <- 0.01
n <- 3000

x <- 1
y <- 1
z <- 1

for(k in 2:n) {
  x[k] <- x[k-1] + dx(x[k-1],y[k-1],z[k-1]) * dt
  y[k] <- y[k-1] + dy(x[k-1],y[k-1],z[k-1]) * dt
  z[k] <- z[k-1] + dz(x[k-1],y[k-1],z[k-1]) * dt
}

plot(y,type='l')

plot(x,y,type='l')