! el almacenamiento por columnas de las matrices en Fortran
! obliga a transponerlas para verlas de forma natural

program ejer
    implicit none
    integer :: a(3,4) = transpose(reshape(    &
                           [ 1, 2, 3, 4       &
                           , 0, 6, 7, 8       &
                           , 0, 0,11, 0],     &
                        [4,3]))

    integer :: b(3,2) = transpose(reshape(    &
                           [ 7,7              &
                           , 0,6              &
                           , 0,5],            &
                        [2,3]))
    
    print '(4I4)', transpose(a)
    print *, triang(a)

    print '(2I4)', transpose(b)
    print *, triang(b)

CONTAINS

function triang(x) 
    logical :: triang
    integer :: x(:,:)
    integer :: r,c,i,j    
    r = size(x,1)
    c = size(x,2)
    triang = .true.
    do i=1,r
        do j=1, min(i-1,c)
            if (x(i,j) /= 0) then
                triang = .false.
                return
            end if
        end do
    end do
end function

end program

