program euler1d
    use graphics
    implicit none

    real :: f, df, x, dx
    
    f=0; x=-5; dx = 1E-2

    call pizarra(800,400,"Euler")
    call fondo(255,255,255)
    call escala(-5.,5.,-5.,5.)
    call color(200,200,200)
    call ejes(1.,1.)    
    

    do while(x<5)        
        df = fun(x)
        f  = f + df*dx
        x  = x + dx
        
        call color(0,0,255)
        call punto(x,df)
        call color(255,0,0)
        call punto(x,f)
    end do

    call esperatecla

contains

    function fun(x)
        real :: fun, x
        fun = exp(-0.5*x**2)
    end

end

