PROGRAM main
    use graphics
    implicit none

    integer :: n = 8

    call pizarra(500,500,"estructura recursiva")
    call autoescala(-2.,2.,0.)
    call fondo(0,32,0)
    call rama(0.,-1.,0.,1.,n)

    call esperatecla
contains


    recursive subroutine rama(x1,y1,x2,y2,nivel)
        real x1,y1,x2,y2
        integer nivel

        real mx,my,dx,dy

        if (nivel==0) then
            call color(0,200,0)
            call recta(x1,y1,x2,y2)
        else
            mx = x1+(x2-x1)*.4
            my = y1+(y2-y1)*.4
            dx = (y2-y1)*.3
            dy = -(x2-x1)*.3

            call color(255,255,255)
            call recta(x1,y1,mx,my)
            call rama(mx,my,x2+dx,y2+dy,nivel-1)
            call rama(mx,my,x2-dx,y2-dy,nivel-1)
        endif

    end 

END
