PROGRAM binary_search
    implicit none
    real :: x
    
    x = root(0.,1.)
    print *, x, f(x)

contains

    function f(x)
        real :: f,x
        f = sin(x) - cos(3*x)
    end function f

    recursive function root(a,b) result(r)
        real :: r,a,b,c
        c = (a+b)/2
        if (abs(a-b) < 0.0001) then
            r = c
        else
            if (f(a)*f(c)<0) then
                r = root(a,c)
            else
                r = root(c,b)
            endif
        endif
    end function root

END program
