PROGRAM ejer
    implicit none
    integer :: n
    do n=4,50,2
        call goldbach(n)
    end do   

CONTAINS

subroutine goldbach(k)
    integer :: k
    integer :: a, b
    do a = 2,k-1
        b = k-a
        if(esPrimo(a) .and. esPrimo(b)) then
            print *, "OK", k, "=", a, "+", b
            return
        end if
    end do
    print *, "NO", k
end subroutine

logical function esPrimo(n)
    integer :: n, k
    esPrimo = .TRUE.
    do k = 2, n-1
        if (mod(n,k)==0) then
            esPrimo = .FALSE.
            return
        end if
    end do
end function

END program

