program ejer
    implicit none

    integer :: n
    real :: ex, ap, er

    do n=1,100
        ex = logfact(n)
        ap = stirling(n)
        er = 100*abs(ex-ap)/ex
        print *, n, ex, ap, er
        if (er < 1) then
            exit
        end if
    end do
    
contains

function logfact(n)
    real :: logfact
    integer :: n
    integer :: k
    logfact = sum( [(log(real(k)), k=1,n)] )
end function


function stirling(n)
    real :: stirling
    integer :: n
    stirling = n * log(real(n)) - n
end function

end program

