"matriz es triangular superior";

% Escribe una función para averiguar si una matriz de enteros es triangular superior
% (es decir, que todos los elementos por debajo de la diagonal son cero).
% Comprueba su funcionamiento en varios casos.

function r = triang(x)
    for i = 1:rows(x)
        for j = 1:columns(x)
            if (i > j) && x(i,j) != 0
                r = 0;  % falso
                return; % y hemos terminado, no hace falta buscar más
            end
        end
    end
    r = 1; % verdadero, si llegamos aquí no hemos encontrado ningún elemento
           % distinto de cero por debajo de la diagonal
end

% comprobación:

a = [ 7   0   1   3
      0   5   1   0
      0   1   0   2
      2   0   0   7 ];

triang(a)

b = [ 1   2   0   4
      0   5   6   0
      0   0   8   9 ];

triang(b)

