! Escriba una función informática `triple(u,v,w)`  para calcular el volumen
! $V = u \cdot (v \times w)$ del paralelepídedo definido por 3 vectores. 
! Comprueba su funcionamiento para $u=(2,1,0)$, $v=(1,2,0)$ y $w=(1,1,2)$,
! cuyo resultado es 6. Se recomienda definir una función auxiliar para calcular
! el producto vectorial (*cross product*) de dos vectores.

program ejer
    implicit none

    print *, cross([1.,2.,3.],[4.,5.,6.])
    print *, 
    print *, triple([2.,1.,0.],[1.,2.,0.],[1.,1.,2.])
    
contains

function cross(x,y)
    real :: x(3), y(3), cross(3)
    cross(1) = x(2)*y(3) - x(3)*y(2)
    cross(2) = x(3)*y(1) - x(1)*y(3)
    cross(3) = x(1)*y(2) - x(2)*y(1)
end function

function triple(u,v,w)
    real :: u(3), v(3), w(3)
    real :: triple
    triple = dot_product(u, cross(v,w))
end function

end program

