program euler1d
    use graphics
    implicit none

    real :: x, v, a, t, dt, maxt
    
    !condiciones iniciales
    x=3; v=0; t=0; maxt=20
    dt = 1E-2
    
    call pizarra(800,400,"Euler")
    call fondo(255,255,255)
    call escala(-1.,maxt,-5.,5.)
    call color(200,200,200)
    call ejes(2.,1.)    


    call color(255,0,0)
    call punto(t,x)

    do while(t<maxt)        
        a = -0.3*x
        
        v  = v + a*dt
        x  = x + v*dt
        t  = t + dt
        call rectaA(t,x)
    end do

    call esperatecla

end

