PROGRAM numint
    implicit none
    integer, parameter :: tot = 10  !intervalos
    double precision :: x (tot+1)
    x = lspc(0D0,1D0,size(x))
    
    print *, integrate(x(2)-x(1), x**4)

contains

    function integrate(delta,f)
        double precision :: integrate, delta, f(:)
        integer :: n        
        n = size(f)
        !integrate = delta * sum(f(2:))
        ! integrate = delta/2 * (2*sum(f(2:n-1))+f(1)+f(n))
        integrate = delta/3 * (f(1)+f(n) + 4*sum(f(2:n-1:2)) + 2*sum(f(3:n-2:2)))
        
        
    end function

    function secu(n)
        integer :: n
        double precision :: secu(n)
        integer :: k
        secu = [ ( real(k), k=1,n) ]
    end function
    
    function lspc(a,b,n)
        integer :: n
        double precision :: a,b, lspc(n)
        lspc = ((b-a)/(n-1))*(secu(n)-1)+a
    end function
END program

