PROGRAM read_matrix_from_file
    implicit none

    real :: a(4,3), b(4,3)
    call read_matrix(a,"../data/m1.txt")
    print *, "primera matriz:"
    call show_matrix('(F7.2)',a)
    
    call read_matrix(b,"../data/m2.txt")
    print *, "segunda matriz:"
    call show_matrix('(F7.2)',b)
    
    print *, "suma:"
    call show_matrix('(F7.2)', a+b)
    
contains 

subroutine read_matrix(m, arch)
    integer, parameter :: u = 10
    real :: m(:,:), mt(size(m,2),size(m,1))
    character (LEn=*)  :: arch
    
    open(unit=u, file=arch, action="read")
    read (unit=u, fmt=*) mt
    m = transpose(mt)
end subroutine
    
subroutine show_matrix(f,m)
    real :: m(:,:)
    character (LEn=*)  :: f
    integer r,c,i,j
    r = size(m,1)
    c = size(m,2)
    
    do i = 1,r
        do j = 1,c
            write (*,f,advance='no') m(i,j)
        end do
        print *
    end do
    
end subroutine
    
END program
