PROGRAM pi
    implicit none
    
    print *, estimapi(1000)
    print *, estimapi(100000000)

contains

    function estimapi(n)
        real estimapi
        integer :: n

        integer :: k,c
        real       :: x,y,r
        
        c = 0
        do k=1,n
            x = randomreal(-1.,1.)
            y = randomreal(-1.,1.)
            r = sqrt(x*x + y**2)
            if (r<1) c=c+1
        end do

        estimapi = 4.0*c/n
    end function estimapi




    function randomreal(a,b)
        real :: randomreal, a, b
        real :: x
        call random_number(x)
        randomreal = (b-a)*x+a
    end function

END program
